# Changelog

#### v5.8.0b2

* **Fix:** The Daily Activity event would not properly trigger while in a cron job *2022-05-23*


#### v5.8.0b1

* **Change:** Rework Daily Activity, Interest, Taxation and Paycheck to use cron jobs rather than login triggers *2022-05-19*
* **Fix:** Prevent donating if either source is incapable of sending, OR target is incapable of receiving, donations *2022-05-19*


#### v5.7.7

* **Fix:** Fix an issue where the "Show to self and designated user groups" currency privacy setting did not apply correctly *2022-03-01*
* **Fix:** Content type reference in the Transaction entity *2022-03-01*
* **Fix:** Fix PHP 8.1 compatibility issue *2022-03-01*


#### v5.7.6

* **Change:** Attempt to resolve issues with Revival events *2021-12-14*
* **Fix:** Fix server error when downloading a resource version *2021-12-14*
* **Fix:** The Wallet widget would not save the correct values when choosing which currencies to display *2021-12-14*


#### v5.7.5

* **Fix:** When viewing options from pages other than the "Settings" page, a server error could be generated *2021-07-20*


#### v5.7.4

* **Fix:** Strip the [CHARGE] BBCode contents when rendering HTML in Email or API contexts *2021-05-04*


#### v5.7.3.1

* **Fix:** Fix regression in 5.7.3 with CHARGE tags *2021-03-07*


#### v5.7.3

* **Fix:** Using the CHARGE BBCode on non-post content will now work as intended *2021-03-04*


#### v5.7.2

* **Fix:** Fixed an issue where integrating with DB Shop would cause a server error if the DB Shop menu is disabled *2021-01-04*
* **Fix:** Fixed an issue where Registration events would not apply if the user required moderation or email confirmation *2021-01-04*


#### v5.7.1

* **Fix:** A server error could occur if the content listed in the transaction was missing *2020-10-11*


#### v5.7.0

* **Feature:** Rebuild action that updates balances based on transaction log balance values *2020-09-30*
* **Fix:** Include the optional message in the Adjust alert/push templates *2020-09-30*


#### v5.7.0b2

* **Fix:** Fix formatted currency values always returning 1 *2020-09-07*


#### v5.7.0b1

* **Feature:** Implement content type link for Currency *2020-08-31*
* **Feature:** Implement better content type linking for transactions *2020-08-31*
* **Change:** Rename negative handling phrase to better reflect its functionality *2020-08-31*
* **Change:** Update internal functions to follow new XenForo 2.1 / 2.2 coding standards *2020-08-31*
* **Fix:** Fix missing space between navbar icon and the text *2020-08-31*
* **Fix:** Fix permissions sometimes not rebuilding when upgrading *2020-08-31*
* **Fix:** Don't award credits when a XFMG media item is added if it isn't visible *2020-08-31*
* **Fix:** Don't award credits when an XFMG comment is posted if it isn't visible *2020-08-31*
* **Fix:** Don't award credits when an attachment is uploaded if the post isn't visible *2020-08-31*


#### v5.6.4

* **Feature:** Add CHARGE BBCode support for XFRM Resource Descriptions, XFRM Resource Updates, XFMG Albums, XFMG Comments, and XFMG Media Items *2020-07-23*
* **Change:** Posts with CHARGE tags that have a cost of 0 will now be rendered normally *2020-07-23*
* **Fix:** Fix an issue with deleting transactions after a currency has been deleted *2020-07-23*


#### v5.6.3

* **Fix:** If XFMG media required approval, credits would be awarded twice *2020-06-25*


#### v5.6.2

* **Change:** Changed the display style of currency values for Ajust and Donate alert / push phrases *2020-06-15*
* **Fix:** Support ThemeHouse UI.X themes when the navbar is configured to appear on the right hand side of the navbar *2020-06-15*
* **Fix:** The currency overlay would not display correctly for mobile users if enough actionable events were enabled *2020-06-15*
* **Fix:** Fixed an issue with the XFMG Media Create event when certain other add-ons are installed *2020-06-15*


#### v5.6.1

* **Change:** Make the Charge BBCode parser a bit more dynamic to prepare for other content types *2020-06-05*
* **Fix:** If the event or currency pertaining to a particular transaction has been deleted, don't try to check permissions *2020-06-05*
* **Fix:** Fix issue with the Credits payment profile *2020-06-05*


#### v5.6.0

* **Feature:** Link back to the content related to a transaction *2020-05-12*
* **Feature:** The "Maximum applications" event limitation can now be applied per-user rather than globally *2020-05-12*
* **Change:** Reworked the installer to make it more manageable going forward *2020-05-12*
* **Change:** Points columns are now stored with a hard cap of 8 decimals *2020-05-12*
* **Change:** When Smart Negation is enabled, Negation events will not occur if a matching Apply event is not found *2020-05-12*
* **Change:** Remove prefix and suffix from currency alert template *2020-05-12*
* **Fix:** Certain broken threads could produce a server error on rebuild *2020-05-12*
* **Fix:** XF Media Gallery Comment class extension would eat comments *2020-05-12*
* **Fix:** Paying with credits could cause a server error in certain circumstances *2020-05-12*
* **Fix:** Alert opt out phrase for the Payment event was missing *2020-05-12*
* **Fix:** If no previous transaction existed, ensure we set a sensible default when negating a transaction *2020-05-12*
* **Fix:** Do not block charged events the user cannot afford if the currency allows negative amounts *2020-05-12*
* **Fix:** Broken "Payment" event alerts have been deleted *2020-05-12*


#### v5.5.0

* **Fix:** Fix an issue where negating a skipped event would incorrectly apply - the negation should also be skipped *2020-04-24*
* **Fix:** Fix an issue where the "Frequency" setting would not work as intended *2020-04-24*


#### v5.5.0b1

* **Feature:** Credits as a Payment Profile *2020-02-17*


#### v5.4.1

* **Fix:** The Purchase event description now supports BBCode as intended *2020-01-02*
* **Fix:** Ensure certain actions can only occur via submitting a form *2020-01-02*


#### v5.4.0

* **Fix:** Birthday event phrases used the wrong phrase key *2019-12-11*
* **Fix:** Purchase event alert phrases did not work as intended *2019-12-11*
* **Fix:** Worked around a race condition where the points column was deleted *2019-12-11*
* **Fix:** Fixed clean installation not having the correct columns *2019-12-11*


#### v5.4.0b1

* **Feature:** Page where users can view their unlocked content *2019-10-21*
* **Change:** Rework Thread / Post editing to only trigger negation when it's absolutely necessary *2019-10-21*


#### v5.3.2

* **Feature:** Currency description now shows up above the tabs in the currency pop-up *2019-10-13*
* **Feature:** Support "tab=" query string parameter to pre-select a tab *2019-10-13*
* **Fix:** Work around a bug in MySQL 5.6+ / MariaDB 10.4 causing slow performance on transactions page *2019-10-13*
* **Fix:** Purchasable type is now removed on uninstall *2019-10-13*


#### v5.3.1

* **Change:** The "Column" field when adding a new currency is now marked as required in the form, preventing database errors in certain scenarios *2019-08-08*
* **Fix:** Transaction alerts were not correctly listed as depending on this add-on *2019-08-08*
* **Fix:** Fixed a missing phrase when adding a new currency *2019-08-08*
* **Fix:** Fixed issues with Richest Users widgets *2019-08-08*
* **Fix:** Fixed incorrect CLI class name preventing the CLI command from running *2019-08-08*


#### v5.3.0

* **Fix:** Ensure alerts are tied to addon ID *2019-06-06*


#### v5.3.0rc3

* **Change:** Updated Approval Queue template for Transactions *2019-05-20*
* **Fix:** Prevent duplicate key exception when inserting a charge purchase *2019-05-20*


#### v5.3.0rc2

* **Change:** Transactions are now deleted in the background when an event is deleted *2019-05-16*
* **Change:** Transactions are now deleted in the background when a currency is deleted *2019-05-16*
* **Fix:** The Purchase event trigger would not correctly log the real-world cost of the purchase in its helper log table *2019-05-16*
* **Fix:** Fix a missing landing page after purchasing credits *2019-05-16*
* **Fix:** Daily, Paycheck, Interest and Taxation events would not trigger correctly if multiple currencies were defined *2019-05-16*


#### v5.3.0rc1

* **Feature:** Smart event negation (beta) *2019-04-24*
* **Feature:** Event transaction moderation *2019-04-24*
* **Feature:** AdminCP transaction list / transaction view now displays the transaction state *2019-04-24*
* **Change:** Editing posts will no longer produce an alert *2019-04-24*
* **Change:** Rework the way Interest, Paycheck and Taxation events are applied in an attempt to reduce race conditions where events would apply into the future *2019-04-24*
* **Change:** AdminCP transaction list now hides "Skipped" and "Skipped (maximum applications)" by default *2019-04-24*
* **Change:** Renamed the Credits alert content types for consistency *2019-04-24*
* **Change:** Number boxes in the AdminCP now use the XF spinbox style *2019-04-24*
* **Fix:** It was not possible to select "both users" for the Taxation setting for certain events *2019-04-24*
* **Fix:** The taxation feature did not function as described in the explanation text *2019-04-24*
* **Fix:** Transaction messages would not respect the forum's censoring *2019-04-24*
* **Fix:** Resolved a server error when limiting the Trophy event *2019-04-24*
* **Fix:** Ensure thread owners won't trigger their own Reply events *2019-04-24*


#### v5.3.0b3

* **Feature:** Added FontAwesome icons for right-side menu entries *2019-03-28*
* **Feature:** Added ability to disable the navbar text for right-side menu entries *2019-03-28*
* **Change:** Updated the style of right-side menu entries to better fit into the surrounding entries *2019-03-28*


#### v5.3.0b2

* **Change:** Switch various "delete" actions to use XF 2.1's deletion plugin *2019-03-23*
* **Fix:** Fix issue where transaction log search in the AdminCP would always return no results *2019-03-23*
* **Fix:** The "Filter" drop-down will no longer produce a server error if no valid events were found *2019-03-23*
* **Fix:** Fix an issue with the Purchase Transaction table that could lead to server errors *2019-03-23*
* **Fix:** Prevent server error when integrating with Shop but the Shop navigation is missing *2019-03-23*


#### v5.3.0b1

* **Feature:** Rebuild transactions *2019-03-15*
* **Feature:** Adjust, Donate, Redeem and Transfer events now have dedidcated log tables to aid in rebuilds *2019-03-15*
* **Feature:** Add missing (unused) permission *2019-03-15*
* **Feature:** Certain permissions are now available to assign to individual moderators as moderator permissions *2019-03-15*
* **Change:** Internally rename some permissions to follow XF standards *2019-03-15*
* **Change:** Ensure only valid users are displayed in the Richest Users widget *2019-03-15*
* **Fix:** Fix an issue causing reduced performance on the Transactions page *2019-03-15*


#### v5.2.1

* **Feature:** React / Reacted event triggers *2019-03-09*


#### v5.2.0

* **Feature:** Add donation reason to donation event alert / push message *2019-02-06*
* **Change:** Updated widgets to feature avatars and a cleaner design *2019-02-06*
* **Fix:** Fix events reverting incorrectly when an entity is saved multiple times in succession *2019-02-06*
* **Fix:** Update FontAwesome icon for Charge tag to be compatible with XF 2.1 FontAwesome changes *2019-02-06*
* **Fix:** Fixed Shop version number check in the installer *2019-02-06*


#### v5.1.0rc3

* **Change:** Added install-upgrade.json file *2018-11-05*
* **Change:** Currency formatting is now applied more universally *2018-11-05*
* **Fix:** The editor.js file is now no longer loaded even on pages where the editor isn't loaded *2018-11-05*
* **Fix:** The "Richest user" widget now respects the limits in the widget settings *2018-11-05*
* **Fix:** The "Frequency" setting for events would cause too many events to be skipped *2018-11-05*


#### v5.1.0rc2

* **Feature:** You can now search for source user and target user separately when searching transaction logs *2018-10-04*
* **Feature:** The CHARGE BBCode now uses an overlay to prompt users for the amount they wish to charge. Only works if the BBCode is still called "CHARGE" *2018-10-19*
* **Fix:** The transaction log searcher in the AdminCP now works as intended *2018-10-04*


#### v5.1.0b7

* **Feature:** New permission: Trigger events - whether user can trigger any event *2018-09-24*
* **Change:** Removed "Block all cancelable event triggers" permission *2018-09-24*
* **Change:** The time zone used for calculating "today" when awarding daily credits has been normalised to use the "Guests' time zone" setting *2018-09-18*
* **Change:** [CHARGE] BBCode tags are now more resilient to post content changes *2018-09-17*
* **Fix:** Fixed an issue with merging or deleting users as a result of a removed database table *2018-09-18*
* **Fix:** Fixed an issue where the currency popup would display an error if no Donate, Adjust, Purchase, Redeem or Transfer events exist in the system *2018-09-17*


#### v5.1.0b6

* **Fix:** Fixed an issue where editing an existing event could erase the contents of the "event_trigger_id" column *2018-09-17*
* **Fix:** Fixed an issue where guests would be unable to view threads and perform certain other actions *2018-09-17*
* **Fix:** Fixed an issue where you would be unable to adjust your own account *2018-09-16*
* **Fix:** Fixed a phrase issue with the alert for Adjust events *2018-09-16*


#### v5.1.0b5

* **Fix:** Fixed an issue preventing adding new events, or saving existing events in a clean install of v5.1 *2018-09-16*


#### v5.1.0b4

* **Fix:** Fixed an issue where the "Frequency" setting in Daily, Interest, Paycheck and Transaction events would not work as intended *2018-09-14*


#### v5.1.0b3

* **Feature:** Individual currencies can now be hidden from the postbit *2018-09-13*
* **Feature:** Individual currencies can now be displayed in the "member dropdown" (A.K.A. "visitor menu") when clicking your own user name *2018-09-13*
* **Change:** Fresh installations will now apply sensible permission defaults *2018-09-13*
* **Change:** The transaction log searcher sort orders can now be extended via a new code event *2018-09-13*
* **Change:** The "Upload" event's integration with attachments has been changed to take advantage of a new feature in XF 2.0.10 *2018-09-13*
* **Change:** This mod now requires XenForo 2.0.10 to install & run *2018-09-13*
* **Fix:** The "Member Stats" integration wasn't working *2018-09-13*


#### v5.1.0b2

* **Change:** Greatly reduced the number of queries executed when viewing a thread *2018-09-01*
* **Fix:** (Hopefully) fixed an issue that could produce a server error when upgrading from v5.0.x *2018-09-01*


#### v5.1.0b1

* **Feature:** New user group permission: Bypass Charge tags *2018-08-31*
* **Change:** Completely rewrote the modification to be a native XenForo 2 modification *2018-08-31*
* **Change:** Removed the "Manage Event Triggers" page, and moved its settings into the XenForo Options *2018-08-31*
* **Change:** If a user attempts to redeem a code that is invalid, they will now receive a message saying so *2018-08-31*
* **Fix:** Fixed permissions issues with viewing transaction log entries *2018-08-31*


#### v5.0.3

* **Fix:** Fixed an issue where the Punish and Warned events could prevent a warning from being given in certain scenarios *2018-07-11*


#### v5.0.2-hotfix2

* Potential fix for template modification *2018-07-06*


#### v5.0.2-hotfix1

* /** *2018-07-06*
* * @param $product *2018-07-06*
* * @param $version *2018-07-06*
* * @param array $opts *2018-07-06*
* */ *2018-07-06*
* public function release($product, $version, $opts = ['dir' => NULL]) *2018-07-06*
* { *2018-07-06*
* $ds = DIRECTORY_SEPARATOR; *2018-07-06*


#### v5.0.2

* *Fix:* Fixed an issue where the addon would not correctly detect it was in the AdminCP *2018-07-05*
* *Fix:* Moderated threads being approved would award the Thread event credits twice *2018-07-05*
* *Fix:* Fix for Post and Reply event negations triggering twice or not correctly *2018-07-05*
